/**********************************************************************
  VKvZX(}V\[X)̒ǉ
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "sim_io.h"

int	create_proc( struct PROCESS_LIST *proc_list, int memsize )
{
int id ;
struct MACHINE_RESOURCE *mres ;

  proc_list->cur_id++ ;
  id   = proc_list->cur_id ;
  mres = &proc_list->proc[id] ;

  if( mres->mem[0x0]!=NULL ){
    free(mres->mem[0x0]) ;
    mres->mem[0x0]=NULL ;
    mres->mem_size[0x0]=0 ;
  }
  
  mres->mem[0x0]=malloc(memsize) ;
  
  if( mres->mem[0x0]==NULL ){
    fprintf(simmsgfp,"mۂł܂ł(size=%d)\n", memsize ) ;
    return(MEM_ALLOC_ERROR) ;
  }
  memset( mres->mem[0x0], 0, memsize ) ;
  mres->mem_size[0x0] = memsize ;

  mres->mem[0x8]=malloc(DEFAULT_PCIMEMSIZE) ;
  if( mres->mem[0x8]==NULL ){
    fprintf(simmsgfp,"mۂł܂ł(size=%d)\n", DEFAULT_PCIMEMSIZE ) ;
    return(MEM_ALLOC_ERROR) ;
  }
  mres->mem_size[0x8] = DEFAULT_PCIMEMSIZE ;
  memset( mres->mem[0x8], 0, DEFAULT_PCIMEMSIZE ) ;
    
#ifdef SUPPORT_GRAPHIC_DEVICE
  mres->mem[0xf]=malloc(GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT) ;
  if( mres->mem[0xf]==NULL ){
    fprintf(simmsgfp,"mۂł܂ł(size=%d)\n", DEFAULT_PCIMEMSIZE ) ;
    return(MEM_ALLOC_ERROR) ;
  }
  memset( mres->mem[0xf], 0, GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT ) ;
  mres->mem_size[0xf] = GRAPHIC_VRAM_WIDTH*GRAPHIC_VRAM_DEPTH*GRAPHIC_SCREEN_HEIGHT ;
#endif

  init_regs( mres ) ;
  mres->heap_top      = default_heaptop ;
  mres->heap_size     = 0 ;
  mres->pc            = default_exec_start ;
  mres->GPR[1].rl     = mres->mem_size[0x0] - default_stack_top_offset ;
  mres->id            = id ;

  return(NORMAL_EXIT) ;
}
