/**********************************************************************
  sR}h
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"

int	op_fetch( struct MACHINE_RESOURCE *mres ) ;
int	op_exec1( struct MACHINE_RESOURCE *mres ) ;
int	op_external_interrupt( struct MACHINE_RESOURCE *mres ) ;
int	op_decrement( struct MACHINE_RESOURCE *mres ) ;
int	op_single_step( struct MACHINE_RESOURCE *mres ) ;
int	chk_single_step( struct MACHINE_RESOURCE *mres ) ;
int	exception( struct MACHINE_RESOURCE *mres , int code ) ;

int	go_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int	excp ;
int	i,exec_num ;
int	break_flag ;
int     id ;
int     do_single_step ;
static	int step_num=1 ;


 id=proc_list.cur_id ;
 break_flag=ON ;
 //݂pcbreak_ptƓꍇ͋^IɃu[N|Cg𖳌ɂ
 if( proc_list.proc[id].bp_num > 0 ){
   for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
     if( proc_list.proc[id].pc==proc_list.proc[id].break_pt[i] ){
       break_flag=OFF ;
       break ;
     }
   }
 }

 if( (mode & GO_STEP_MODE)==0 ){
   exec_num=-1 ;
 }else{
   if( tk_pt->pt[1]!=NULL ){
     exec_num=exatoi( tk_pt->pt[1] ) ;
     if( exec_num>0 ) step_num=exec_num ;
     else{
       fprintf(simmsgfp,"Invalid step number. range=1-%d\n",0x7fffffff) ;
       return(NORMAL_EXIT) ;
     }
   }
   exec_num=step_num ;
 }

 set_sighandl_ppcsim() ;
 while ( -1 ) {
   if( sig_int != 0 ) break ;

   excp = op_decrement( &proc_list.proc[id] ) ; // occurd declement exception
   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], excp) ;
     if( excp!=0 ) break ;
   }
   
   excp = op_external_interrupt( &proc_list.proc[id] ) ; // occurd declement exception
   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], excp) ;
     if( excp!=0 ) break ;
   }
   
   excp = op_fetch( &proc_list.proc[id] ) ;
   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], (excp | OPFETCH_FLAG) ) ;
     if( excp<0 ) break ;
     if( excp>0 ) continue ;
   }
   
   if( break_flag==ON && proc_list.proc[id].bp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].bp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].break_pt[i] ){
	 break_flag=OFF ;
	 fprintf(simmsgfp,"Exec stop by break point.\n") ;
	 fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
		 proc_list.proc[id].pc,
		 proc_list.proc[id].inst) ;
	 return(NORMAL_EXIT) ;
       }
     }
   }
   
   if( break_flag==ON && iexe_count==proc_list.proc[id].break_inum ){
     fprintf(simmsgfp,"Exec stop by break num of exec instruction.\n") ;
     fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
	     proc_list.proc[id].pc,
	     proc_list.proc[id].inst) ;
     break ;
   }
   
   if( proc_list.proc[id].pp_num > 0 ){
     for( i=0 ; i<proc_list.proc[id].pp_num ; i++ ){
       if( proc_list.proc[id].pc==proc_list.proc[id].pass_pt[i] ){
	 switch( pp_msg ){
	 case PP_DUMP_PC :
	   fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   break ;
	 case PP_DUMP_GPR :
	   fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
	   break ;
	 case PP_DUMP_ALL :
	   fprintf(simmsgfp,"Passed pc=0x%08x inst=0x%08x\n",
		   proc_list.proc[id].pc,
		   proc_list.proc[id].inst) ;
	   print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
	   break ;
	 default :
	 }
	 break ;
       }
     }
   }
   break_flag=ON ;
   trace_history[trace_ptr].pc   = proc_list.proc[id].pc ;
   trace_history[trace_ptr].inst = proc_list.proc[id].inst ;
   trace_ptr++ ;
   trace_ptr=trace_ptr%HISTORY_SIZE ;
   iexe_count++ ;
   if( iexe_count==0x80000000 ){
     iexe_count =0 ;
     iexe_count2++ ;
   }
   if( (mode & (GO_ALL_DUMP | GO_GPR_DUMP | GO_PC_DUMP))!=0 ){
     fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
	     proc_list.proc[id].pc,
	     proc_list.proc[id].inst) ;
   }
   if( (mode & GO_GPR_DUMP)!=0 ){
     print_regs( &proc_list.proc[id], PRINT_GPR_AND_OTHERS ) ;
   }
   if( (mode & GO_ALL_DUMP)!=0 ){
     print_regs( &proc_list.proc[id], PRINT_ALLREGISTERS ) ;
   }
   
   do_single_step=chk_single_step( &proc_list.proc[id] ) ;
   
   excp = op_exec1( &proc_list.proc[id] ) ;
   sim_io( &proc_list.proc[id] ) ;

   if( excp !=0 ){
     excp=exception( &proc_list.proc[id], excp ) ;
     if( excp!=0 ){
       if( (mode & (GO_ALL_DUMP | GO_GPR_DUMP | GO_PC_DUMP))==0 ){
	 fprintf(simmsgfp,"pc=0x%08x inst=0x%08x\n",
	 	 proc_list.proc[id].pc,
	 	 proc_list.proc[id].inst) ;
       }
       break ;
     }
   }

   if( do_single_step==YES ){
     excp = op_single_step( &proc_list.proc[id] ) ; // occurd single step exception
     if( excp !=0 ){
       excp=exception( &proc_list.proc[id], excp ) ;
       if( excp!=0 ) break ;
     }
   }
   
   exec_num-- ;
   if( exec_num==0 ) break ;
   else if( exec_num<0 ) exec_num=-1 ;
 }

 return(NORMAL_EXIT) ;
}
