/**********************************************************************
  ߎs ̂Q
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "funcs.h"
#include "processor.h"
#include "memory.h"
#include "op_exec.h"

int	op_exec2( struct MACHINE_RESOURCE *mres )
{
register unsigned int op2,op3 ;
register unsigned int inst ;
unsigned int	updt_cr, updt_ovflow ;
int             adrs_update ;
unsigned int 	ea ;
unsigned int	r1,r2,r3 ;

 inst=mres->inst ;
 op2 = inst & 0x000003fe ;
 op3 = inst & 0x000007fe ;
 r1  = (inst & 0x03e00000)>>21 ; // rD rS
 r2  = (inst & 0x001f0000)>>16 ; // rA rA
 r3  = (inst & 0x0000f800)>>11 ; // rB rB
 updt_cr     = inst & 0x00000001 ;
 updt_ovflow = inst & 0x00000400 ;
 
 switch( op3 ){
   unsigned int chkbit ;
   int i,count ;
   unsigned int crm,flag ;
   unsigned int cr ;
   
   //lbzx,lbzux,lhzx,lhzux,lhax,lhaux,lwzx,lwzux
 case 0x000000ee :
 case 0x000000ae :
 case 0x000002ee :
 case 0x000002ae :
 case 0x0000026e :
 case 0x0000022e :
 case 0x0000002e :
 case 0x0000006e :
   adrs_update = op2&0x00000040 ;
   if( r2==r1 && adrs_update!=0 ) return( INSTFORM_IS_INVALID ) ;
   if( r2==0 ){
     if( adrs_update!=0 ){
        return( INSTFORM_IS_INVALID ) ;
     }
     ea=mres->GPR[r3].rl ;
   }else{
     ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
   }
   switch( (op2 & 0x000002b0) ){
   case 0x000000a0 : //lbzx,lbzux
     fetchu1b(mres->GPR[r1].rl,ea) ;
     break ;
   case 0x00000220 : //lhzx,lhzux
     fetchu2b(mres->GPR[r1].rl,ea) ;
     break ;
   case 0x000002a0 : //lhax,lhaux
     fetchs2b(mres->GPR[r1].rl,ea) ;
     break ;
   case 0x00000020 : //lwzx,lwzux
     fetchu4b(mres->GPR[r1].rl,ea) ;
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
   mres->pc+=4 ;
   return(0) ;
   
   //stbx,stbux,sthx,sthux,stwx,stwux
 case 0x000001ee :
 case 0x000001ae :
 case 0x0000036e :
 case 0x0000032e :
 case 0x0000016e :
 case 0x0000012e :
   
   adrs_update = op2&0x00000040 ;
   if( r2==0 ){
     if( adrs_update!=0 ){
        return( INSTFORM_IS_INVALID ) ;
     }
     ea=mres->GPR[r3].rl ;
   }else{
     ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
   }
   switch( (op2 & 0x000002b0) ){
   case 0x000000a0 : //stbx,stbux
     storeu1b(mres->GPR[r1].rl,ea) ;
     break ;
   case 0x00000220 : //sthx,sthux
     storeu2b(mres->GPR[r1].rl,ea) ;
     break ;
   case 0x00000020 : //stwx,stwux
     storeu4b(mres->GPR[r1].rl,ea) ;
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
   mres->pc+=4 ;
   return(0) ;
   
   //lfsx,lfsux,lfdx,lfdux
 case 0x0000042e :
 case 0x0000046e :
 case 0x000004ae :
 case 0x000004ee :
   adrs_update = op2&0x00000040 ;
   if( r2==0 ){
     if( adrs_update!=0 ) {
        return( INSTFORM_IS_INVALID ) ;
     }
     ea=mres->GPR[r3].rl ;
   }else{
     ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
   }
   switch( (op2 & 0x00000080) ){
   case 0x00000000 : //lfsx,lfsux
     fetchf4b(mres->FPR[r1].f,ea) ;
     break ;
   case 0x00000080 : //lfdx,lfdux
     fetchd8b(mres->FPR[r1].f,ea) ;
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
   mres->pc+=4 ;
   return(0) ;
   
   //stfsx,stfsux,stfdx,stfdux,stfiwx
 case 0x0000052e :
 case 0x0000056e :
 case 0x000005ae :
 case 0x000005ee :
 case 0x000007ae :
   adrs_update = op2&0x00000040 ;
   if( r2==0 ){
     if( adrs_update!=0 ) {
        return( INSTFORM_IS_INVALID ) ;
     }
     ea=mres->GPR[r3].rl ;
   }else{
     ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
   }
   switch( (op2 & 0x00000280) ){
   case 0x00000000 : //stfsx,stfsux
     storef4b(mres->FPR[r1].f,ea) ;
     break ;
   case 0x00000080 : //stfdx,stfdux
     stored8b(mres->FPR[r1].f,ea) ;
     break ;
   case 0x00000280 : //stfiwx
     {
       unsigned int  *cast_uint,uint_tmp ;
       
       cast_uint = (unsigned int *)&mres->FPR[r1].f ;
#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
#else
       cast_uint++ ;
#endif
       uint_tmp=*cast_uint ;
       storeu4b(uint_tmp,ea) ;
     }
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   if( adrs_update!=0 ) mres->GPR[r2].rl=ea ;
   mres->pc+=4 ;
   return(0) ;
   
   // and,and.
 case 0x00000038 :
   mres->GPR[r2].rl = mres->GPR[r1].rl & mres->GPR[r3].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // or,or.
 case 0x00000378 :
   mres->GPR[r2].rl = mres->GPR[r1].rl | mres->GPR[r3].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // xor,xor.
 case 0x00000278 :
   mres->GPR[r2].rl = mres->GPR[r1].rl ^ mres->GPR[r3].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // nand,nand.
 case 0x000003b8 :
   mres->GPR[r2].rl = ~(mres->GPR[r1].rl & mres->GPR[r3].rl) ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // nor,nor.
 case 0x000000f8 :
   mres->GPR[r2].rl = ~(mres->GPR[r1].rl | mres->GPR[r3].rl) ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // eqv,eqv.
 case 0x00000238 :
   mres->GPR[r2].rl = ~(mres->GPR[r1].rl ^ mres->GPR[r3].rl) ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // andc,andc.
 case 0x00000078 :
   mres->GPR[r2].rl = mres->GPR[r1].rl & ~mres->GPR[r3].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // orc,orc.
 case 0x00000338 :
   mres->GPR[r2].rl = mres->GPR[r1].rl | ~mres->GPR[r3].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // extsb,extsb.
 case 0x00000774 :
   mres->GPR[r2].rl = mres->GPR[r1].rl & 0x000000ff ;
   if( (mres->GPR[r2].rl & 0x00000080)!=0 ) mres->GPR[r2].rl = mres->GPR[r2].rl | 0xffffff00 ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // extsh,extsh.
 case 0x00000734 :
   mres->GPR[r2].rl = mres->GPR[r1].rl & 0x0000ffff ;
   if( (mres->GPR[r2].rl & 0x00008000)!=0 ) mres->GPR[r2].rl = mres->GPR[r2].rl | 0xffff0000 ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // cntlzw,cntlzw.
 case 0x00000034 :
   for( i=0,chkbit=0x80000000,count=0 ; i<32 ; i++,chkbit>>=1 ){
     if( (mres->GPR[r1].rl & chkbit) == 0 ){
       count++ ;
     }else{
       break ;
     }
   }
   mres->GPR[r2].rl = count ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   //slw,slw.
 case 0x00000030 :
   mres->GPR[r2].rl = mres->GPR[r1].rl<<(mres->GPR[r3].rl & 0x0000003f) ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   //srw,srw.
 case 0x00000430 :
   mres->GPR[r2].rl = mres->GPR[r1].rl>>(mres->GPR[r3].rl & 0x0000003f) ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   //srawi,srawi.
 case 0x00000670 :
   {
     unsigned int flg ;
     int i ;
     mres->FLGR.xer &=~0x20000000 ;     //reset Carry
     if( (mres->GPR[r1].rl & 0x80000000)!=0 && r3!=0 ){
       for( i=0,flg=0x00000001 ; i<r3 ; i++,flg+=flg ){
	 if( (mres->GPR[r1].rl & flg)!=0 ){
	   mres->FLGR.xer |= 0x20000000 ;     //set Carry
	   break ;
	 }
       }
     }
   }
   mres->GPR[r2].rl = (int)mres->GPR[r1].rl>>r3 ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   //sraw,sraw.
 case 0x00000630 :
   {
     unsigned int flg ;
     int i,sh ;
     sh=mres->GPR[r3].rl & 0x0000003f ;
     mres->FLGR.xer &=~0x20000000 ;     //reset Carry
     if( (mres->GPR[r1].rl & 0x80000000)!=0 && sh!=0 ){
       for( i=0,flg=0x00000001 ; i<sh ; i++,flg+=flg ){
	 if( (mres->GPR[r1].rl & flg)!=0 ){
	   mres->FLGR.xer |= 0x20000000 ;     //set Carry
	   break ;
	 }
       }
     }
   }
   mres->GPR[r2].rl = (int)mres->GPR[r1].rl>>(mres->GPR[r3].rl & 0x0000003f) ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r2].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   //mfspr,mtspr
 case 0x000002a6 :
 case 0x000003a6 :
   switch( op3 ){
   case 0x000002a6 : //mfspr
     mres->GPR[r1].rl = *mres->SPR[r3*32+r2] ;
     break ;
   case 0x000003a6 : //mtspr
     *mres->SPR[r3*32+r2] = mres->GPR[r1].rl ;
     break ;
   default :
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc+=4 ;
   return(0) ;
   
   // lwbrx
 case 0x0000042c :
   if( r2==0 ) ea=mres->GPR[r3].rl ;
   else        ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
   fetchu4b(mres->GPR[r1].rl,ea) ;
   mres->GPR[r1].rl= (mres->GPR[r1].rl & 0xff000000)>>24 | (mres->GPR[r1].rl & 0x00ff0000)>>8 | \
                     (mres->GPR[r1].rl & 0x000000ff)<<24 | (mres->GPR[r1].rl & 0x0000ff00)<<8 ;
   mres->pc+=4 ;
   return(0) ;
   
   //mfcr,mtcrf
 case 0x00000026 : //mfcr
 case 0x00000120 : //mtcrf
 case 0x000000a6 : //mfmsr
 case 0x00000124 : //mtmsr
 case 0x000004a6 : //mfsr
   switch( op3 ){
   case 0x00000026 : //mfcr
     mres->GPR[r1].rl=0 ;
     for( i=0 ; i<8 ; i++ ){
       mres->GPR[r1].rl |= mres->FLGR.cr[i]>>(i*4) ;
     }
     break ;
   case 0x00000120 : //mtcrf
     crm = (inst & 0x000ff000) ;
     flag= 0x00080000 ;
     for( i=0 ; i<8 ; i++,flag=flag>>1 ){
       if( (crm & flag)!=0 ){
	 mres->FLGR.cr[i] = (mres->GPR[r1].rl<<(i*4))&0xf0000000 ;
       }
     }
     break ;
   case 0x000000a6 : //mfmsr
     //crm = (inst & 0x000ff000) ; /**crm0x00Oo͂Ȃ**/
     mres->GPR[r1].rl = *mres->MSR ;
     break ;
   case 0x00000124 : //mtmsr
     //crm = (inst & 0x000ff000) ; /**crm0x00Oo͂Ȃ**/
     *mres->MSR = mres->GPR[r1].rl ;
     break ;
   case 0x000004a6 : //mfsr
     if( r2 > 15 ) return(INSTFORM_IS_INVALID) ;
     mres->GPR[r1].rl = *mres->SR[r2] ;
     break ;
   case 0x000001a4 : //mtsr
     if( r2 > 15 ) return(INSTFORM_IS_INVALID) ;
     *mres->SR[r2] = mres->GPR[r1].rl ;
     break ;
   default :
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc+=4 ;
   return(0) ;
   
   //cmp,cmpl
 case 0x00000000 :
 case 0x00000040 :
   
   cr= (inst & 0x03800000)>>23 ;
   switch( op3 & 0x00000040 ){
   case 0x00000000 :
     if( (int)mres->GPR[r2].rl == (int)mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x20000000 ;
     else                                     mres->FLGR.cr[cr] &=~0x20000000 ;
     if( (int)mres->GPR[r2].rl >  (int)mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x40000000 ;
     else                                     mres->FLGR.cr[cr] &=~0x40000000 ;
     if( (int)mres->GPR[r2].rl <  (int)mres->GPR[r3].rl ) mres->FLGR.cr[cr] |= 0x80000000 ;
     else                                     mres->FLGR.cr[cr] &=~0x80000000 ;
     if( (mres->FLGR.xer & 0x80000000)!=0 )         mres->FLGR.cr[cr] |= 0x10000000 ;
     else                                     mres->FLGR.cr[cr] &=~0x10000000 ;
     break ;
   case 0x00000040 :
     if( mres->GPR[r2].rl == mres->GPR[r3].rl )   mres->FLGR.cr[cr] |= 0x20000000 ;
     else                             mres->FLGR.cr[cr] &=~0x20000000 ;
     if( mres->GPR[r2].rl >  mres->GPR[r3].rl )   mres->FLGR.cr[cr] |= 0x40000000 ;
     else                             mres->FLGR.cr[cr] &=~0x40000000 ;
     if( mres->GPR[r2].rl <  mres->GPR[r3].rl )   mres->FLGR.cr[cr] |= 0x80000000 ;
     else                             mres->FLGR.cr[cr] &=~0x80000000 ;
     if( (mres->FLGR.xer & 0x80000000)!=0 ) mres->FLGR.cr[cr] |= 0x10000000 ;
     else                             mres->FLGR.cr[cr] &=~0x10000000 ;
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   mres->pc+=4 ;
   return(0) ;
 case 0x000004ac ://sync
   mres->pc+=4 ; //Ƃ肠NOP
   return(0) ;
   
 case 0x000004aa : //lswi
   if( r2==0 ) ea=0 ;
   else        ea=mres->GPR[r2].rl ;
   {
     int i,n ;
     unsigned int ui ;
     if( r3==0 ) n=32 ;
     else        n=r3 ;
     for( i=0 ; i<n ; i++ ){
       if( (i%4)==0 ) mres->GPR[((i/4)+r1)%32].rl=0 ;
       fetchu1b( ui, (ea+i) ) ;
       mres->GPR[((i/4)+r1)%32].rl = mres->GPR[((i/4)+r1)%32].rl | (ui << ((3-(i%4))*8)) ;
     }
   }
   mres->pc+=4 ;
   return(0) ;
 case 0x000005aa : //stswi
   if( r2==0 ) ea=0 ;
   else        ea=mres->GPR[r2].rl ;
   {
     int i,n ;
     unsigned int ui ;
     if( r3==0 ) n=32 ;
     else        n=r3 ;
     for( i=0 ; i<n ; i++ ){
       ui = (mres->GPR[((i/4)+r1)%32].rl & (0xff000000 >> (((i%4))*8))) >> ((3-(i%4))*8) ;
       storeu1b( ui, (ea+i) ) ;
     }
   }
   mres->pc+=4 ;
   return(0) ;
 case 0x000001e4 : //mfsrin
   mres->GPR[r1].rl = *mres->SR[r3%16] ;
   mres->pc+=4 ;
   return(0) ;
 case 0x00000028 : //lwarx
   if( r2==0 ){
     ea=mres->GPR[r3].rl ;
   }else{
     ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
   }
   fetchu4b(mres->GPR[r1].rl,ea) ;
   *mres->RSV  =1  ;
   *mres->RSVAD=ea ;
   mres->pc+=4 ;
   return(0) ;
 case 0x0000012c : //stwcx.
   if( updt_cr!=0 ){
     if( r2==0 ){
       ea=mres->GPR[r3].rl ;
     }else{
       ea=mres->GPR[r2].rl + mres->GPR[r3].rl ;
     }
     if( *mres->RSV==1 ){
       if( *mres->RSVAD==ea ){
	 storeu4b(mres->GPR[r1].rl,ea) ;
	 mres->FLGR.cr[0] |= 0x20000000 ;
       }else{
	 // AhXϊŃANZX\ł΃XgAł
	 // simł̓AhXϊsȂ̂ŕKXgAł
	 storeu4b(mres->GPR[r1].rl,ea) ;
	 mres->FLGR.cr[0] |= 0x20000000 ;
       }
       *mres->RSV=0 ;
     }else{
       mres->FLGR.cr[0] &= ~0x20000000 ;
     }
     mres->pc+=4 ;
     return(0) ;
   }else{
     return( INSTFORM_IS_INVALID ) ;
   }
 case 0x000002e6 : //mftb
   {
     int tbr_num ;
     tbr_num=r3*32+r2 ;
     if(       tbr_num==268 ){
       mres->GPR[r1].rl = *mres->TBL ;
     }else if( tbr_num==269 ){
       mres->GPR[r1].rl = *mres->TBU ;
     }else{
       return( INSTFORM_IS_INVALID ) ;
     }
   }
   mres->pc+=4 ;
   return(0) ;
 case 0x00000264 : //tlbie   Ƃ肠nop
   mres->pc+=4 ;
   return(0) ;
 case 0x0000006c : //dcbst 肠NOP
 case 0x000000ac : //dcbf  肠NOP
 case 0x000001ec : //dcbtst肠NOP
 case 0x0000022c : //dcbt  肠NOP
 case 0x000003ac : //dcbi(SuperVisor Instruction)肠NOP
 case 0x000007ac : //icbi  肠NOP
 case 0x000007ec : //dcbz  肠NOP
 case 0x000006ac : //eieio 肠NOP
   mres->pc+=4 ;
   return(0) ;
 }
 
 switch( op2 ){
   unsigned int tmpui0,tmpui1,tmpui2,bit32c ;
   unsigned int ans ;
   
   // add,add.,addo
 case 0x00000214 :
   bit32c=0 ;
   if( (mres->GPR[r2].rl & 0x00000001)==1 && (mres->GPR[r3].rl & 0x00000001)==1 ) bit32c=1 ;
   tmpui1=mres->GPR[r2].rl>>1 ;
   tmpui2=mres->GPR[r3].rl>>1 ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = mres->GPR[r2].rl + mres->GPR[r3].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // subf,subf.,subfo
 case 0x00000050 :
   bit32c=((~mres->GPR[r2].rl & 0x00000001)+
	   (mres->GPR[r3].rl & 0x00000001)+1)>>1 ;
   tmpui1=~mres->GPR[r2].rl>>1 ;
   tmpui2=mres->GPR[r3].rl>>1 ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = mres->GPR[r3].rl - mres->GPR[r2].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // addc,addc.,addco
 case 0x00000014 :
   bit32c=0 ;
   if( (mres->GPR[r2].rl & 0x00000001)==1 && (mres->GPR[r3].rl & 0x00000001)==1 ) bit32c=1 ;
   tmpui1=mres->GPR[r2].rl>>1 ;
   tmpui2=mres->GPR[r3].rl>>1 ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = mres->GPR[r2].rl + mres->GPR[r3].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // subfc,subfc.,subfco
 case 0x00000010 :
   bit32c=((~mres->GPR[r2].rl & 0x00000001)+
	   (mres->GPR[r3].rl & 0x00000001)+1)>>1 ;
   tmpui1=~mres->GPR[r2].rl>>1 ;
   tmpui2=mres->GPR[r3].rl>>1 ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = mres->GPR[r3].rl - mres->GPR[r2].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // adde,adde.,addeo
 case 0x00000114 :
   ans = mres->GPR[r2].rl + mres->GPR[r3].rl + ((mres->FLGR.xer & 0x20000000)!=0);
   bit32c= (((mres->GPR[r2].rl&0x00000001)+
	     (mres->GPR[r3].rl&0x00000001)+
	     ((mres->FLGR.xer&0x20000000)!=0)
	     )&0x00000002)>>1 ;
   tmpui1=mres->GPR[r2].rl>>1 ;
   tmpui2=mres->GPR[r3].rl>>1 ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = ans ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // subfe,subfe.,subfeo
 case 0x00000110 :
   ans = mres->GPR[r3].rl + ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
   bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	     (mres->GPR[r3].rl&0x00000001)+
	     ((mres->FLGR.xer&0x20000000)!=0)
	     )&0x00000002)>>1 ;
   tmpui1=~mres->GPR[r2].rl>>1 ;
   tmpui2=mres->GPR[r3].rl>>1 ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = ans ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // addme,addme.,addmeo
 case 0x000001d4 :
   ans = mres->GPR[r2].rl + 0xffffffff + ((mres->FLGR.xer & 0x20000000)!=0);
   bit32c= (((mres->GPR[r2].rl&0x00000001)+
	     1+
	     ((mres->FLGR.xer&0x20000000)!=0)
	     )&0x00000002)>>1 ;
   tmpui1=mres->GPR[r2].rl>>1 ;
   tmpui2=0x7fffffff ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = ans ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // subfme,subfme.,subfmeo
 case 0x000001d0 :
   ans = 0xffffffff + ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
   bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	     1+
	     ((mres->FLGR.xer&0x20000000)!=0)
	     )&0x00000002)>>1 ;
   tmpui1=~mres->GPR[r2].rl>>1 ;
   tmpui2=0x7fffffff ;
   tmpui0=tmpui1+tmpui2+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = ans ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // addze,addze.,addzeo
 case 0x00000194 :
   ans = mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0);
   bit32c= (((mres->GPR[r2].rl&0x00000001)+
	     ((mres->FLGR.xer&0x20000000)!=0)
	     )&0x00000002)>>1 ;
   tmpui1=mres->GPR[r2].rl>>1 ;
   tmpui0=tmpui1+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = ans ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // subfze,subfze.,subfzeo
 case 0x00000190 :
   ans = ~mres->GPR[r2].rl + ((mres->FLGR.xer & 0x20000000)!=0) ;
   bit32c= (((~mres->GPR[r2].rl&0x00000001)+
	     ((mres->FLGR.xer&0x20000000)!=0)
	     )&0x00000002)>>1 ;
   tmpui1=~mres->GPR[r2].rl>>1 ;
   tmpui0=tmpui1+bit32c ;
   if( (tmpui0&0x80000000)!=0 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = ans ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   // neg,neg.,nego
 case 0x000000d0 :
   if( mres->GPR[r2].rl==0x00000000 ){
     mres->FLGR.xer |= 0x20000000 ;   //set Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer |= 0x80000000 ; //set SO
       mres->FLGR.xer |= 0x40000000 ; //set OV
     }
   }else{
     mres->FLGR.xer &=~0x20000000 ;   //reset Carry
     if( updt_ovflow != 0 ){
       mres->FLGR.xer &=~0x40000000 ; //reset OV
     }
   }
   mres->GPR[r1].rl = -mres->GPR[r2].rl ;
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   //mullw,mullw.mullwo,mulhw,mulhw.,mulhwu,mulhwu.
 case 0x000001d6 :
 case 0x00000096 :
 case 0x00000016 :
   // I[o[t[oI
   switch( op2 ){
     int i ;
     unsigned int w0,w1,w2 ;
     unsigned int t0,t1,t2 ;
     unsigned int c1,c2 ;
     unsigned int tmpa,tmpb ;
     unsigned int msk ;
   case 0x000001d6 : //mullw,mullw.mullwo
     mres->GPR[r1].rl = (long long)(mres->GPR[r2].rl * mres->GPR[r3].rl) ;
     break ;
   case 0x00000096 : //mulhw,mulhw.
     w0=0 ; w1=0 ; w2=0 ;
     if( (mres->GPR[r2].rl & 0x80000000)==0 ) tmpa=mres->GPR[r2].rl ;
     else                               tmpa=(~mres->GPR[r2].rl)+1 ;
     if( (mres->GPR[r3].rl & 0x80000000)==0 ) tmpb=mres->GPR[r3].rl ;
     else                               tmpb=(~mres->GPR[r3].rl)+1 ;
     // fprintf(simmsgfp,"tmpa=%08X , tmpb=%08X\n",tmpa,tmpb) ;
     t0=0 ;
     t1=(tmpa&0x80000000)>>31 ;
     t2=(tmpa&0x7fffffff) ;
     msk=0x00000001 ;
     for( i=0 ; i<32 ; i++ ){
       if( (tmpb & msk)!=0 ){
	 c1=0 ; c2=0 ;
	 w2=w2+t2 ;
	 if( (w2 & 0x80000000)!=0 ){
	   w2&=0x7fffffff ;
	   c2++ ;
	 }
	 w1=w1+t1+c2 ;
	 if( (w1 & 0x80000000)!=0 ){
	   w1&=0x7fffffff ;
	   c1++ ;
	 }
	 w0=w0+t0+c1 ;
       }
       msk<<=1 ;
       t2<<=1 ;
       if( (t2 & 0x80000000)!=0 ){
	 t2&=0x7fffffff ;
	 t1<<=1 ; t1|=1 ;
       }else{
	 t1<<=1 ;
       }
       if( (t1 & 0x80000000)!=0 ){
	 t1&=0x7fffffff ;
	 t0<<=1 ; t0|=1 ;
       }else{
	 t0<<=1 ;
       }
     }
     tmpa=mres->GPR[r2].rl & 0x80000000 ;
     tmpb=mres->GPR[r3].rl & 0x80000000 ;
     mres->GPR[r1].rl = ((w0&3)<<30) | (w1>>1) ;
     // fprintf(simmsgfp,"res1=%08X\n",mres->GPR[r1].rl) ;
     if( (tmpa!=0 && tmpb==0) || (tmpa==0 && tmpb!=0) ){
       mres->GPR[r1].rl=(~mres->GPR[r1].rl)+1 ;
     }
     // fprintf(simmsgfp,"res2=%08X\n",mres->GPR[r1].rl) ;
     /*	mres->GPR[r1].rl = (long long)((int)(mres->GPR[r2].rl * (int)mres->GPR[r3].rl)/0x80000000)/2 ;*/
     break ;
   case 0x00000016 : //mulhwu,mulhwu.
     w0=0 ; w1=0 ; w2=0 ;
     t0=0 ;
     t1=(mres->GPR[r2].rl&0x80000000)>>31 ;
     t2=(mres->GPR[r2].rl&0x7fffffff) ;
     msk=0x00000001 ;
     for( i=0 ; i<32 ; i++ ){
       if( (mres->GPR[r3].rl & msk)!=0 ){
	 c1=0 ; c2=0 ;
	 w2=w2+t2 ;
	 if( (w2 & 0x80000000)!=0 ){
	   w2&=0x7fffffff ;
	   c2++ ;
	 }
	 w1=w1+t1+c2 ;
	 if( (w1 & 0x80000000)!=0 ){
	   w1&=0x7fffffff ;
	   c1++ ;
	 }
	 w0=w0+t0+c1 ;
       }
       msk<<=1 ;
       t2<<=1 ;
       if( (t2 & 0x80000000)!=0 ){
	 t2&=0x7fffffff ;
	 t1<<=1 ; t1|=1 ;
       }else{
	 t1<<=1 ;
       }
       if( (t1 & 0x80000000)!=0 ){
	 t1&=0x7fffffff ;
	 t0<<=1 ; t0|=1 ;
       }else{
	 t0<<=1 ;
       }
     }
     mres->GPR[r1].rl = ((w0&3)<<30) | (w1>>1) ;
     /*mres->GPR[r1].rl = (long long)((mres->GPR[r2].rl * mres->GPR[r3].rl)/0x80000000)/2 ;*/
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
   
   //divw,divw.,divwo,divwu,divwu.,divwuo
 case 0x000003d6 :
 case 0x00000396 :
   // I[o[t[oI
   // PowerPCł0ZO̊TOB0Z̖߂l0
   if( mres->GPR[r3].rl==0 ){
     if( excp_stat.e2f00.stat == DISABLE ){ //ppcsim̓ʏu
       mres->GPR[r1].rl=0 ;
       if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
       mres->pc+=4 ;
       return(0) ;
     }else{
       return(DIVIDED_BY_ZERO) ;
     }
   }
   switch( op2 ){
   case 0x000003d6 : //divw,divw.,divwo
     mres->GPR[r1].rl = (int)mres->GPR[r2].rl / (int)mres->GPR[r3].rl ;
     break ;
   case 0x00000396 : //divwu,divwu.,divwuo
     mres->GPR[r1].rl = mres->GPR[r2].rl / mres->GPR[r3].rl ;
     break ;
   default : 
     return(UNKNOWN_INSTRUCTION) ;
   }
   if( updt_cr != 0 ) update_cr( mres->GPR[r1].rl ) ;
   mres->pc+=4 ;
   return(0) ;
 }
 
 return(UNKNOWN_INSTRUCTION) ;
}
