/**********************************************************************
  ȈIOfoCX
  $Id:$
**********************************************************************/

/*** Output only console device ***/
#define CONSOLE_OUT_CMD      0x8000ff00

/*** DISK device ***/
#define DISK_CMD             0x8000ff10
#define DISK_ACK             0x8000ff14
#define DISK_DRIVE           0x8000ff18
#define DISK_TRACK           0x8000ff1c
#define DISK_DATA_TOP        0x8000ff20
#define DISK_DATA_LEN        0x8000ff24

#define DISK_INQ_LEN         256

#define DISK_NOP             0x00
#define DISK_INQ             0x01
#define DISK_READ            0x02
#define DISK_WRITE           0x03
#define DISK_WRITE_INQ       0x04

#define DISK_ACK_IDLE        0x00
#define DISK_ACK_BUSY        0x01
#define DISK_ACK_FAIL        0x81

#define SIM_IO_DISK_MOUNT_FAIL  0x00000001

#define VENDER_ID_LEN      32
#define DISK_INFO_PADING  208
#define VENDER_ID         "SIMLATION_DISK"

struct sim_disk_info_struct{
  unsigned char vender_id[VENDER_ID_LEN] ; /** x_[ID                 32byte **/
  int  type     ;                          /** DISK TYPE                   4byte **/
  int  tnum     ;                          /** gbN                  4byte **/
  int  tlen     ;                          /** 1gbÑoCg   4byte **/
  int  reserve1 ;                          /** pfBO                  4byte **/
  unsigned char pading[DISK_INFO_PADING] ; /** gp̈                208byte **/
} ;

#define SIM_DISK_DRIVE_NUM   16

struct sim_disk_struct{
  int mount ;
  int type ;
  int tnum ;
  int tlen ;
  struct sim_disk_info_struct *info ;
  unsigned char *buf ;
} ;
struct sim_disk_struct sim_disk[SIM_DISK_DRIVE_NUM] ;

#define DISK_TYPE_EN_READ     0x00000001
#define DISK_TYPE_EN_WRITE    0x00000002
#define DISK_TYPE_EN_EJECT    0x00000004

/*** Clock device ***/
#define CLOCK_READ_CMD        0x8000ff30
#define CLOCK_DATA            0x8000ff34


/*** Graphic device ***/
#ifdef SUPPORT_GRAPHIC_DEVICE

#include <windows.h>
#include "gdevlib.h"

#define GRAPHIC_VRAM_SYNC     0x8000ff40
#define GRAPHIC_VRAM_TOP      0xf0000000
#define GRAPHIC_VRAM_WIDTH    2048
#define GRAPHIC_VRAM_DEPTH    4

#define GRAPHIC_SCREEN_WIDTH  640
#define GRAPHIC_SCREEN_HEIGHT 480
#define GRAPHIC_NAME          "PPCSIM Graphic Device"

void actionfunc(int c) ;

#endif

/*********************************************************************
============================
  Output only console device
============================
  CONSOLE_OUT_CMD_ADRS  '\0' ȊO unsigned char ^f[^
  stdoutASCIIo͂B


============================
  DISK
============================
  DISK_CMD_ADRS ɃR}hގŃfBXNfoCXANZXB

     DISK_READ
       DISK_DRIVEŎw肳ꂽhCuDISK_TRACKŎw肵gbN
       DSIK_DATA_TOPŎw肵DISK_DATA_LENoCgǂ
       ݂܂B
  
     DISK_WRITE
       DISK_DRIVEŎw肳ꂽhCuDISK_TRACKŎw肵gbN
       DSIK_DATA_TOPŎw肵DISK_DATA_LENoCg
       ݂܂B

     DISK_INQ
       fBXN̏DISK_DATA_TOPŎw肵DISK_INQ_LEN
       oCg݂܂Bf[^\̎̂struct sim_disk_info_struct
       ̂́BGfBA̓rbOGfBAB

   DISK_ACK
     ANZX̌ʂԂ܂B
     DMAV~[gĊ荞݂gKɏł悤ɂׂB

=================
  Clock device
=================
  vfoCX

  time()ŕԂ time_t tH[}bg̎Ԃ rbOGfBA
  i[B

 *********************************************************************/



